import { type Board } from './Board';
import { type Cell } from './Cell';
import { type Config } from './Config';
import { type PatternJson } from './PatternJson';
export declare class Pattern {
    readonly board: Board;
    readonly cells: Cell[];
    constructor(board: Board, cells: Cell[]);
    canBePlaced(config: Config): boolean;
    clone(): Pattern;
    collides(): boolean;
    getIndexOfFirstCellWithoutTile(): number;
    getEmptyCellsCount(): number;
    goesThroughBoardCenter(): boolean;
    hasAtLeast1EmptyCell(): boolean;
    hasAtLeast1NonEmptyCell(): boolean;
    getCollisions(): Pattern[];
    toJson(): PatternJson;
    toString(): string;
}
